require 'sketchup.rb'
require 'test/unit'


class TC_OSM4SketchUp

def test_take_screenshot
  Sketchup.open_file(@localized_model)
  @model = Sketchup.active_model

  p1 = @model.point_to_latlong([50.m,50.m,0])
  p2 = @model.point_to_latlong([-50.m,-50.m,0])
  bounds = {"top" => p1.y.to_f, "right" => p1.x.to_f, "bottom" => p2.y.to_f, "left" => p2.x.to_f}

  before = @model.entities.to_a
  materials_before = @model.materials.to_a
  MyPlugin.take_screenshot(@model, bounds)
  after = @model.entities.to_a
  materials_after = @model.materials.to_a

  spec = "It should add a new textured material to the model"
  assert(materials_after.length == materials_before.length + 1, spec)
  material = (materials_after - materials_before)[0]
  assert(material.is_a?(Sketchup::Material), spec)
  assert(material.texture.is_a?(Sketchup::Texture), spec)

  spec = "It should add a new group to the model"
  assert(after.length == before.length + 1, spec)
  group = (after - before)[0]
  assert(group.is_a?(Sketchup::Group), spec)

  spec = "The group contains a textured face"
  assert(group.entities.grep(Sketchup::Face) != nil, spec)
  face = group.entities.grep(Sketchup::Face)[0]
  assert(face.material == material, spec)
end

end